var bingo = bingo || {
	
    config: {
        spielModus: 'klassisch',
        gegnerAnzahl: 3,
        ZeitAbstandZiehung: 10,
        AnzahlBingoKarten: 2,
        SpielHilfe: 'off',
        configUeberpruefung: false,
        geladen: false,
        gameover: false
    },
    
    data: {
        drawnNumbers: new Array(),
        basis: 0,
        nummer: 0,
        zahlenReihenfolge: new Array(),
        gegner: new Array(),
        spielerWin: new Array(),
        alreadyMarked: new Array(),
        markedNumbers: new Array(),
        muster:			new Array()
    },
    
    init: function () {
        bingo.bindings();
    },
    
    injektions: function () {
    },
     
    bindings: function () {
    	
    	$('#spielModus').change(function(){
    		bingo.config.spielModus = this.value;
    		console.log(bingo.config.spielModus);
    	});
    	
    	$('#computerSpieler').change(function(){
    		var test = this.value;
    		bingo.config.gegnerAnzahl = parseInt(test);
    		console.log(bingo.config.gegnerAnzahl);
    	});
    	
    	$('#zeitAbstand').change(function(){
    		var test = this.value;
    		bingo.config.ZeitAbstandZiehung= parseInt(test);
    		console.log(bingo.config.ZeitAbstandZiehung);
    	});
    	
    	$('#bingoKarten').change(function(){
    		var test = this.value;
    		bingo.config.AnzahlBingoKarten = parseInt(test);
    		console.log(bingo.config.AnzahlBingoKarten);
    	});
    	
    	$('#Spielhilfe').change(function(){
    		bingo.config.SpielHilfe = (this.form.Spielhilfe.checked ? this.form.Spielhilfe.value : 'off')
    		console.log(bingo.config.SpielHilfe);
    	});
    	  	
    	$('#zeigeSpielregeln').click(function(){
       		if($('#spielRegeln').hasClass('animated')){
       			$('#spielRegeln').dequeue().stop();
       		}
       		$('#spielRegeln').addClass('animated');
    		$('#spielRegeln').toggle(
    	    		function(){
    	    			$('#spielRegeln').removeClass('animated');
    	    		});
    	});
    	
    	
       	$('#zeigeOptionen').click(function(){
       		if($('#spielOptionen').hasClass('animated')){
       			$('#spielOptionen').dequeue().stop();
       		}
       		$('#spielOptionen').addClass('animated');
    		$('#spielOptionen').toggle(
    	    		function(){
    	    			$('#spielOptionen').removeClass('animated');
    	    		});
    	});
    	
    	
    	// ueberpruefen der SpielConfig, wenn diese erfolgreich war, berechne Reihenfolge der gezogenen Zahlen
    	// sage die Nummer und zeige den fortschritt bis zur nächsten ziehung an
    	// generiere den spieler und seine Karten
    	// generiere die gegner und generiere deren Karten
        $('#spielen').click(function () {
            bingo.ueberpruefeConfig();
            if (bingo.config.configUeberpruefung == true) {
                if ($('#Spieloberflaeche').css('display') == 'none') {
                    $('#Spieloberflaeche').css('display', 'block');
                    $('#Hauptmenu').css('display', 'none');
                    bingo.bestimmeZahlenReihenfolge(bingo.data.zahlenReihenfolge);
                    if (bingo.config.geladen == true) {
                    	if(bingo.config.spielModus == 'Muster'){
                    		bingo.createMuster();
                    	}
                        bingo.callNumber();
                        bingo.progressbar();
                        bingo.erstelleSpieler();
                        for (var i = 0; i < parseInt(bingo.config.gegnerAnzahl); i++) {
                            var a = bingo.gibGewinnmoeglichkeiten();
                            bingo.data.gegner.push(a);
                        }
                    }
                }
            }
        });
    },
    
    ueberpruefeConfig: function () {
        if (bingo.config.spielModus == 'klassisch' || bingo.config.spielModus == 'FullCard' || bingo.config.spielModus == 'Muster') {
            console.log('Gamemode allowed');
            if (parseInt(bingo.config.gegnerAnzahl) < 4) {
                console.log('Number of Enemys allowed');
                if (parseInt(bingo.config.ZeitAbstandZiehung) > 9 && parseInt(bingo.config.ZeitAbstandZiehung) < 16) {
                    console.log('Delay between new draw allowed');
                    if (parseInt(bingo.config.AnzahlBingoKarten) > 0 && parseInt(bingo.config.AnzahlBingoKarten) < 4) {
                        console.log('Number of cards allowed');
                        if (bingo.config.SpielHilfe == 'off') {
                            console.log('everything ok, start Game');
                            bingo.config.configUeberpruefung = true;
                        }
                        if (bingo.config.SpielHilfe == 'on') {
                            console.log('everything ok, start game with help');
                            bingo.config.configUeberpruefung = true;
                        }
                    }
                }
            }
        }
    },
    // zeigt alle bereits gezogenen Nummern den Spieler an
    aktiviereSpielhilfe: function () {
        var zeichenkette2 = bingo.data.drawnNumbers.join(',');
        var zeichenkette = ('Bereits gezogene Zahlen: ');
        $('#spielHilfe').text(zeichenkette + zeichenkette2);
    },
    
    erstelleSpieler: function () {
        var Karten = new Array();
        for (var i = 0; i < parseInt(bingo.config.AnzahlBingoKarten); i++) {
            Karten.push(bingo.gibGewinnmoeglichkeiten());
        }
        
        for (var i = 0; i < Karten.length; i++) {
            var table = $('<table></table>');
            for (var a = 0; a < 5; a++) {
                var tablerow = $('<tr></tr>');
                for (var b = 0; b < Karten[i][a].length; b++) {
                    tablerow.append('<td>' + Karten[i][a][b] + '</td>');
                }
                table.append(tablerow);
            }
            $('body').append(table);
        }

        $('table tr td').addClass('clickables');
        $('.clickables').click(function () {
        	 var clicked = parseInt($(this).text());
        	 	$(this).toggleClass("marked");
                 if ($.inArray(clicked, bingo.data.markedNumbers) == - 1) {
                     bingo.data.markedNumbers.push(clicked);
                 }else {
                	 if($(this).hasClass("marked") == false){
                		 var markedObjekts = $('.marked');
                		 var alleMarkiertenZahlen = new Array();
                		 markedObjekts.each(function () {
                			var markierteZahl = parseInt($(this).text());
                			alleMarkiertenZahlen.push(parseInt(markierteZahl));
                		 }); 
                			var vorhanden = $.inArray(clicked, alleMarkiertenZahlen);
                			if(vorhanden == -1){
                				bingo.data.markedNumbers.splice($.inArray(clicked, bingo.data.markedNumbers), 1);
                			}
                	 }
            	 }
                 
        });
 
        $('table').prepend('<tr><td>B</td><td>I</td><td>N</td><td>G</td><td>O</td></tr>');
        bingo.data.spielerWin = Karten;
    },
    
    neueKarte: function (Karte) {
        if (Karte == undefined) {
            Karte = new Array();
        }
        var basis = Math.floor(Karte.length / 5);
        var nummer = basis * 15 + Math.floor(Math.random() * 15) + 1;
        var vorhanden = $.inArray(nummer, Karte);
        if (vorhanden == - 1) {
            Karte.push(nummer);
        }
        if (Karte.length < 25) {
            return bingo.neueKarte(Karte);
        } else {
            return Karte;
        }
    },
    
    bestimmeZahlenReihenfolge: function (ZahlenReihenfolge) {
        if (ZahlenReihenfolge == undefined) {
            ZahlenReihenfolge = new Array();
        }
        var nummer = Math.floor(Math.random() * 75) + 1;
        var vorhanden = $.inArray(nummer, ZahlenReihenfolge);
        if (vorhanden == - 1) {
            ZahlenReihenfolge.push(nummer);
        }
        if (ZahlenReihenfolge.length != 75) {
            return bingo.bestimmeZahlenReihenfolge(ZahlenReihenfolge);
        }
        if (ZahlenReihenfolge.length == 75) {
            bingo.config.geladen = true;
            bingo.data.zahlenReihenfolge = ZahlenReihenfolge;
            return ZahlenReihenfolge;
        }
    },
    
    callNumber: function (index) {
        if (bingo.config.gameover == false) {
            if (index == undefined) {
                index = 0;
            }
            if (bingo.config.geladen == false) {
                console.log('Bitte haben sie einen Moment geduld, es geht gleich los');
            } else {
                if (index != 75) {
                    var zuSagendeNummer = bingo.data.zahlenReihenfolge[index];
                    $('#gezogeneNummer').text('Es wurde die Nummer ' + zuSagendeNummer + ' gezogen!');
                    bingo.data.drawnNumbers.push(zuSagendeNummer);
                    if (bingo.config.SpielHilfe == 'on') {
                        bingo.aktiviereSpielhilfe();
                    }
                    console.log('Bereits gezogene Nummern:');
                	console.log(bingo.data.drawnNumbers.sort(function(a, b){return a-b}));
                    index = index + 1;
                    setTimeout(function () {
                        bingo.spieleGegner();
                        bingo.progressbar();
                        return bingo.callNumber(index);
                    }, parseInt(bingo.config.ZeitAbstandZiehung) * 1000);
                }
            }
        }
    },
    
    gibGewinnmoeglichkeiten: function (karte) {
        if (karte == undefined) {
            var karte = bingo.neueKarte(new Array());
        }
        var gewinnmoeglichkeiten = new Array();
            for (var i = 0; i < 7; i++) {
                gewinnmoeglichkeiten[i] = new Array();
                if (i < 5) {
                    for (var a = 0; a < 5; a++) {
                        gewinnmoeglichkeiten[i].push(karte[i + a * 5]);
                    }
                }
                if (i == 5) {
                    for (var b = 0; b < 5; b++) {
                        gewinnmoeglichkeiten[i].push(karte[b * 6]);
                    }
                }
                if (i == 6) {
                    for (var c = 0; c < 5; c++) {
                        gewinnmoeglichkeiten[i].push(karte[4 + c * 4]);
                    }
                }
            }
        return gewinnmoeglichkeiten;
    },
    
    spieleGegner: function () {
        if (bingo.config.gameover == false) {
        	if(bingo.config.spielModus == 'klassisch'){
            for (var z = 0; z < bingo.data.gegner.length; z++) { 
                for (var y = 0; y < bingo.data.gegner[z].length; y++) { 
                    for (var i = 0; i < bingo.data.drawnNumbers.length; i++) { 
                        var zahl = bingo.data.drawnNumbers[i];
                        if ($.inArray(zahl, bingo.data.gegner[z][y]) != - 1) {
                            console.log('Gegner ' + bingo.data.gegner[z] + ' hat Zahl ' + zahl + 'markiert');
                            bingo.data.gegner[z][y].splice($.inArray(zahl, bingo.data.gegner[z][y]), 1);
                        }
                    }
                }
            }

            for (var u = 0; u < bingo.data.gegner.length; u++) { 
                for (var o = 0; o < bingo.data.gegner[u].length; o++) { 
                    if (bingo.data.gegner[u][o] == '') {
                    	bingo.enemyWins();
                    }
                }
            }
        }
        	
            if(bingo.config.spielModus == 'FullCard') {
            	var gegner = bingo.data.gegner;
            	var siegmoeglichkeiten = new Array();
            	for(var i = 0; i < gegner.length; i++){
            		for(var z = 0; z < gegner[i].length; z++){
            			var siegmoeglichkeit = new Array();
            			var string = "";
            			var string2 = "";
            			for(var u = 0; u < 5; u++){
            				var string = (gegner[i][u].join());
            				var string2 = string + "," + string2;
            			}
            		}siegmoeglichkeiten.push(string2);
            	}
            	
            	var karten = new Array();
            	for(var i = 0; i < siegmoeglichkeiten.length; i++){
            		var x = siegmoeglichkeiten[i].split(',');
            		x.splice(25,1);
            		x.sort(function(a,b){return a-b});
            		var karte = new Array();
            		for(var a = 0; a < x.length; a++){
            			karte.push(parseInt(x[a]));
            		}
            		karten.push(karte);
            	}
            	var gezogeneNummern = bingo.data.drawnNumbers;
            	for(var u = 0; u < karten.length; u++){
                	for(var i = 0; i < gezogeneNummern.length; i++){
                		var vorhanden = $.inArray(gezogeneNummern[i], karten[u]);
                		if(vorhanden != -1){
                			karten[u].splice(vorhanden,1);
                			console.log(karten);
                			if(karten[u].length == 0){
                				bingo.enemyWins();
                			}
                		}
                	}
            	}      
           }
            
            
            if (bingo.config.spielModus == 'Muster') {
            	var zuErreichendeZahlen = bingo.data.muster;
            	var gezogeneNummern = bingo.data.drawnNumbers;
            	var gegner = bingo.data.gegner;
            	var zuKontrollieren = new Array();
            		for(var u = 0; u < gegner.length; u++){
            			var enemy = new Array();
            			//console.log(gegner[u]); // jeweiliger gegner
            			var karte = (bingo.gibZahlenVonKarte(gegner[u]));	// jeweilige Karte
            			for(var i = 0; i < zuErreichendeZahlen.length; i++){
            				var index = zuErreichendeZahlen[i];
            				enemy.push(karte[index]);
            			}
            			console.log("Siegeschance fuer Gegner :");
            			console.log(enemy); // jeweiliges Muster mit den zu ziehenden Zahlen der Gegner
            			for(var i = 0; i < gezogeneNummern.length; i++){
            				var vorhanden = $.inArray(gezogeneNummern[i],enemy);
            				if(vorhanden != -1){
            					enemy.splice(vorhanden,1);
            					if(enemy.length == 0){
            						bingo.enemyWins();
            					}
            				}
            			}
            		}
            }
      }
    },
    
    createMuster: function() {
    	bingo.data.muster = new Array();
    	for(var i = 0; i < 5; i++){
    		var min = i * 5;
    		var max = i * 5 + 4;
    		var nummer = Math.floor(Math.random()*(max-min)+min);
    		if($.inArray(nummer,bingo.data.muster) == -1) {
    			bingo.data.muster.push(nummer);
    		}else{
    			i = i - 1;
    		}
    	}
    	bingo.zeigeMuster();
    	console.log(bingo.data.muster);
    },
    
    zeigeMuster: function() {
    	var Karte = bingo.neueKarte();
    	for(var i = 0; i < bingo.data.muster.length; i++){
    		var index = bingo.data.muster[i];
    		Karte[index] = "x";
    	}
    	console.log(Karte);
    	Karte = bingo.gibGewinnmoeglichkeiten(Karte);
    	console.log(Karte);
            var table = $('<table></table>');
            for (var a = 0; a < 5; a++) {
                var tablerow = $('<tr></tr>');
                for (var b = 0; b < Karte[a].length; b++) {
                    tablerow.append('<td>' + Karte[a][b] + '</td>');
                }
                table.append(tablerow);
            }
            $('body').append(table);
        
    },
    
    gibZahlenVonKarte: function(siegChanchen) {
    	var Karte = new Array();
    	for(var i = 0; i < siegChanchen.length; i++){
    		for(var z = 0; z < siegChanchen[i].length; z++){
    			Karte.push(siegChanchen[i][z]);
    		}
    	}
    	return Karte
    },
    
    enemyWins: function() {
    	var random = Math.floor(Math.random() * 3 + 1);
		switch(random) {
			case 1:
				var bild = 'images/gegner1.bmp';
				break;
			case 2:
				var bild = 'images/gegner2.bmp';
				break;
			case 3:
				var bild = 'images/gegner3.bmp';
				break;
		}
		$('#caller').attr('src', bild);
		alert('Das Spiel ist beendet. Ein Gegenspieler hat das Spiel gewonnen!');
		bingo.config.gameover = true;
		window.location.reload();
		return false;
    },
    
    checkPlayerBingo: function() {
    	var spielerKarten = bingo.data.spielerWin;
    	var markierteZahlen = bingo.data.markedNumbers;
    	var gezogeneNummern = bingo.data.drawnNumbers;

    	if(bingo.config.spielModus == 'klassisch') {
    		var spielerKarten = bingo.data.spielerWin;
    		var markierteZahlen = bingo.data.markedNumbers;
    		var gezogeneNummern = bingo.data.drawnNumbers;

    		for(var i = 0; i < spielerKarten.length; i++) {
    			for(var o = 0; o < spielerKarten[i].length; o++) {
    				for(var p = 0; p < markierteZahlen.length; p++) {
    					if($.inArray(markierteZahlen[p], gezogeneNummern) != -1) {
    						if($.inArray(markierteZahlen[p], spielerKarten[i][o]) != -1) {
    							spielerKarten[i][o].splice($.inArray(markierteZahlen[p], spielerKarten[i][o]), 1);
    						}
    					}
    				}
    				if(spielerKarten[i][o].length == 0) {
    					alert('Du hast das Spiel gewonnen!');
    					window.location.reload();
    					return false;
    				}
    			}
    		}
    	}
    	
    	if(bingo.config.spielModus == 'FullCard'){
    		var markierteZahlen = bingo.data.markedNumbers;
        	var gezogeneNummern = bingo.data.drawnNumbers;
        	var spieler = bingo.data.spielerWin;
        		for(var u = 0; u < spieler.length; u++){
        			//console.log(spieler[u]); // jeweiliger spieler
        			var karte = (bingo.gibZahlenVonKarte(spieler[u]));	// jeweilige Karte des Spielers
        			karte.splice(24,10);
        			//console.log(karte); jeweilige Karte des Spielers
        			for(var i = 0; i < gezogeneNummern.length; i++){
        				var vorhanden = $.inArray(gezogeneNummern[i],karte);
        				console.log(karte);
        				if(vorhanden != -1 && $.inArray(gezogeneNummern[i],markierteZahlen) != -1){
        					karte.splice(vorhanden,1);
        					if(karte.length == 0){
            					alert('Du hast das Spiel gewonnen!');
            					window.location.reload();
            					return false;
        					}
        				}
        			}
        		}		

    		}
    	
        if (bingo.config.spielModus == 'Muster') {
        	var markierteZahlen = bingo.data.markedNumbers;
        	var zuErreichendeZahlen = bingo.data.muster;
        	var gezogeneNummern = bingo.data.drawnNumbers;
        	var spieler = bingo.data.spielerWin;
        		for(var u = 0; u < spieler.length; u++){
        			var zuKontrollieren = new Array();
        			console.log(spieler[u]); // jeweiliger spieler
        			var karte = (bingo.gibZahlenVonKarte(spieler[u]));	// jeweilige Karte des Spielers
        			karte.splice(24,10);
        			for(var i = 0; i < zuErreichendeZahlen.length; i++){
        				var index = bingo.gibRichtigeZahl(zuErreichendeZahlen[i]);
        				console.log(index);
        				zuKontrollieren.push(karte[index]);// jeweilige Karte vom Muster des Spielers
        			}
        			console.log("Siegeschance fuer den Spieler :");
        			console.log(zuKontrollieren); // jeweiliges Muster mit den zu ziehenden Zahlen der Spieler
        			for(var i = 0; i < gezogeneNummern.length; i++){
        				var vorhanden = $.inArray(gezogeneNummern[i],zuKontrollieren);
        				if(vorhanden != -1 && $.inArray(gezogeneNummern[i],markierteZahlen) != -1){
        					zuKontrollieren.splice(vorhanden,1);
        					if(zuKontrollieren.length == 0){
            					alert('Du hast das Spiel gewonnen!');
            					window.location.reload();
            					return false;
            				}
        					}
        				}
        			}
        		}
        
    },
    // umrechnen, das muster generiert sich von oben nach unten, die karten jedoch von links nach rechts! 
    //also was bei dem muster 1 ist, ist bei der karte index 5 usw. da 0,5,10 usw. und bei der anderen 0,1,2 usw.
    gibRichtigeZahl: function (zahl){
    	switch (zahl){
    	case 0:
    		return 0;
    	case 1:
    		return 5;
    	case 2:
    		return 10;
    	case 3:
    		return 15;
    	case 4:
    		return 20;
    	case 5:
    		return 1;
    	case 6:
    		return 6;
    	case 7:
    		return 11;
    	case 8:
    		return 16;
    	case 9:
    		return 21;
    	case 10:
    		return 2;
    	case 11:
    		return 7;
    	case 12:
    		return 12;
    	case 13:
    		return 17;
    	case 14:
    		return 22;
    	case 15:
    		return 3;
    	case 16:
    		return 8;
    	case 17:
    		return 13;
    	case 18:
    		return 18;
    	case 19:
    		return 23;
    	case 20:
    		return 4;
    	case 21:
    		return 9;
    	case 22:
    		return 14;
    	case 23:
    		return 19;
    	case 24:
    		return 24;
    	}
    },
    
    progressbar: function () {
        var zeitspanne = parseInt(bingo.config.ZeitAbstandZiehung) * 1000;
        $('#progress').animate({
            width: '100%'
        }, {
            duration: zeitspanne,
            easing: 'linear',
            complete: function () {
                $('#progress').width(0);
            }
        });
    }
}
$(document).ready(function () {
    bingo.init();
});



// karte x zu gezogenen Zahlen hinzufuegen: bingo.data.drawnNumbers = bingo.gibZahlenVonKarte(bingo.data.spielerWin[x]);